#include "forms.h"
#include "debugform.h"
#include "Z80.h"

extern FD_debugform *fd_debugform;

extern word PCdir[];
extern int DisOffset;
#define NDIS 13
#define DISSPACE 1024
extern int StackOffset;
extern word Mem;
extern byte DebugMod;
extern byte Step;
extern word Next;
extern word Brk;
extern byte BrkOn;
extern reg *Rp;

extern void showDis(reg *);
extern void showStack(reg *);
extern void showMem();
extern void showReg(reg *);

#define	RUN	0
#define TRACE	1
#define	NEXT	2
#define	STOP	3

/* callbacks for form debugform */

void browserDis(FL_OBJECT *ob, long data)
{
	char buf[16];
	Brk=PCdir[DisOffset+fl_get_browser(ob)-1];
	sprintf(buf,"%04X",Brk);
	fl_set_input(fd_debugform->inputBrk,buf);
	BrkOn=1;
}

void inputA(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->AF.B.h=i&0xff;
	showReg(Rp);
}

void inputBC(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->BC.W=i&0xffff;
	showReg(Rp);
}

void inputDE(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->DE.W=i&0xffff;
	showReg(Rp);
}

void inputHL(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->HL.W=i&0xffff;
	showReg(Rp);
}

void inputIX(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->IX.W=i&0xffff;
	showReg(Rp);
}

void inputIY(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->IY.W=i&0xffff;
	showReg(Rp);
}

void botondirBC(FL_OBJECT *ob, long data)
{
	Mem=Rp->BC.W;
	showMem();
}

void inputMem(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Mem=i&0xffff;
	showMem();
}

void inputBC1(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->BC1.W=i&0xffff;
	showReg(Rp);
}

void inputDE1(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->DE1.W=i&0xffff;
	showReg(Rp);
}

void inputHL1(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->HL1.W=i&0xffff;
	showReg(Rp);
}

void inputA1(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->AF1.B.h=i&0xff;
	showReg(Rp);
}

void inputI(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->I=i&0xff;
	showReg(Rp);
}

void inputR(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->R=i&0xff;
	showReg(Rp);
}

void botonIFF0(FL_OBJECT *ob, long data)
{
	if (fl_get_button(ob)) Rp->IFF|=1;
	else Rp->IFF&=0xfe;
}

void inputSP(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->SP.W=i&0xffff;
	showReg(Rp);
	showStack(Rp);
}

void inputPC(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Rp->PC.W=i&0xffff;
	showReg(Rp);
	showDis(Rp);
}

void botonIFF1(FL_OBJECT *ob, long data)
{
	if (fl_get_button(ob)) Rp->IFF|=0x40;
	else Rp->IFF&=0xbf;
}

void botondirDE(FL_OBJECT *ob, long data)
{
	Mem=Rp->DE.W;
	showMem();
}

void botondirHL(FL_OBJECT *ob, long data)
{
	Mem=Rp->HL.W;
	showMem();
}

void botondirIX(FL_OBJECT *ob, long data)
{
	Mem=Rp->IX.W;
	showMem();
}

void botondirIY(FL_OBJECT *ob, long data)
{
	Mem=Rp->IY.W;
	showMem();
}

void botondirBC1(FL_OBJECT *ob, long data)
{
	Mem=Rp->BC1.W;
	showMem();
}

void botondirDE1(FL_OBJECT *ob, long data)
{
	Mem=Rp->DE1.W;
	showMem();
}

void botondirHL1(FL_OBJECT *ob, long data)
{
	Mem=Rp->HL1.W;
	showMem();
}

void botonSTEP(FL_OBJECT *ob, long data)
{
	DebugMod=STOP;
	Step=1;
}

void botonTRACE(FL_OBJECT *ob, long data)
{
  	DebugMod=TRACE;
  	Step=1;
}

void botonRUN(FL_OBJECT *ob, long data)
{
	DebugMod=RUN;
	Step=1;
	fl_clear_browser(fd_debugform->browserDis);
}

void inputBrk(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	Brk=i&0xffff;
	BrkOn=1;
}

void botonSTOP(FL_OBJECT *ob, long data)
{
	DebugMod=STOP;
}

void botonNEXT(FL_OBJECT *ob, long data)
{
	Next=PCdir[1];
	DebugMod=NEXT;
	Step=1;
	fl_clear_browser(fd_debugform->browserDis);
}

void inputIM(FL_OBJECT *ob, long data)
{
	char buf[128];
	int i;
	sprintf(buf,"0x%s",fl_get_input(ob));
	sscanf(buf,"%x",&i);
	i&=3; i<<=1;
	Rp->IFF&=0xf9;
	Rp->IFF|=i;
	showReg(Rp);
}

void botonF1(FL_OBJECT *ob, long data)
{
	if (fl_get_button(ob)) {
		Rp->AF1.B.l|=data;
	} else {
		Rp->AF1.B.l&=~data;
	}
}

void botonF(FL_OBJECT *ob, long data)
{
	if (fl_get_button(ob)) {
		Rp->AF.B.l|=data;
	} else {
		Rp->AF.B.l&=~data;
	}
}

void botonMemDec(FL_OBJECT *ob, long data)
{
	Mem-=8;
	showMem();
}

void botonMemInc(FL_OBJECT *ob, long data)
{
	Mem+=8;
	showMem();
}

void botonC(FL_OBJECT *ob, long data)
{
	fl_set_input(fd_debugform->inputBrk,"");
	BrkOn=0;
}

void botonDisInc(FL_OBJECT *ob, long data) 
{
	if (DisOffset+NDIS<DISSPACE) DisOffset++;
	showDis(Rp);
}

void botonDisDec(FL_OBJECT *ob, long data)
{
	if (DisOffset>0) DisOffset--;
	showDis(Rp);
}

void botonStackInc(FL_OBJECT *ob, long data) 
{
	StackOffset++;
	showStack(Rp);
}

void botonStackDec(FL_OBJECT *ob, long data)
{
	if (StackOffset>0) StackOffset--;
	showStack(Rp);
}
