#include <forms.h>
#include <X11/Xlib.h> 
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <stdlib.h>
#include "woprform.h"

#define NDIGIT 6
#define DISPX 16
#define DISPY 30
#define DEFAULT_SCALE 4
#define ITALIC 8

#define DIMM 3
#define COLOR_R 65535
#define COLOR_G 10000
#define COLOR_B 0


static int ndigit=NDIGIT, dispx=DISPX,dispy=DISPY;
static int ww=DISPX*NDIGIT,wh=DISPY;

static XPoint Seg[7][6]={
3,3,	4,2,	12,2,	13,3,	12,4,	4,4,	/* Seg. a */
13,4,	14,5,	14,13,	13,14,	12,13,	12,5,	/* Seg. b */
13,16,	14,17,	14,25,	13,26,	12,25,	12,17,	/* Seg. c */
3,27,	4,26,	12,26,	13,27,	12,28,	4,28,	/* Seg. d */
3,16,	4,17,	4,25,	3,26,	2,25,	2,17,	/* Seg. e */
3,4,	4,5,	4,13,	3,14,	2,13,	2,5,	/* Seg. f */
3,15,	4,14,	12,14,	13,15,	12,16,	4,16	/* Seg. g */
};

static XPoint dp={16,27};	/* Decimal Point location */
int dpr=1;			/* Decimal Point radius */

Display *mydisplay;
Window mywindow;
GC mygc;
XColor color1,color0;

extern FD_woprform *fd_woprform;

void setup7seg(){
	int i,j,s,bx,by,myscreen;
	Colormap cmap;

	mydisplay=fl_display;
	mywindow=fl_winget();
	mygc=fl_state[fl_get_form_vclass(NULL)].gc[0];
	
	myscreen=DefaultScreen(mydisplay);
	cmap=DefaultColormap(mydisplay,myscreen);

	color1.red=COLOR_R;
	color1.green=COLOR_G;
	color1.blue=COLOR_B;
	XAllocColor(mydisplay,cmap,&color1);
	color0.red=COLOR_R/DIMM;
	color0.green=COLOR_G/DIMM;
	color0.blue=COLOR_B/DIMM;
	XAllocColor(mydisplay,cmap,&color0);

	s=DEFAULT_SCALE;
	dispx*=s;
	dispy*=s;
	ww*=s;
	wh*=s;
	bx=(int)fd_woprform->display_box->x;
	by=(int)fd_woprform->display_box->y;
	bx+=((int)fd_woprform->display_box->w - ww - wh/ITALIC)/2;
	by+=((int)fd_woprform->display_box->h - wh)/2;
	
	for (j=0;j<7;j++)
		for (i=0;i<6;i++) {
			Seg[j][i].x*=s;
			Seg[j][i].y*=s;
			Seg[j][i].x+=(dispy-Seg[j][i].y)/ITALIC;
			
			Seg[j][i].x+=bx;
			Seg[j][i].y+=by;
		}
	dp.x*=s; dp.y*=s; dpr*=s;
	dp.x+=bx;
	dp.y+=by;
	ww+=dispy/ITALIC;
}

void Draw7s(unsigned char dat,int pos)
{
	int i,j,col;
	XPoint seg[6];
	
	if (pos>=ndigit) return;
	
	for (i=0;i<7;i++) {
		for (j=0;j<6;j++) {
			seg[j]=Seg[i][j];
			seg[j].x+=pos*dispx;
		}
		if (dat&1) col=color1.pixel; else col=color0.pixel;
		XSetForeground(mydisplay,mygc,col);		
		XFillPolygon(mydisplay,mywindow,mygc,seg,6,Nonconvex,CoordModeOrigin);
		dat>>=1;
	}
	if (dat) col=color1.pixel; else col=color0.pixel;
	XSetForeground(mydisplay,mygc,col);	
	i=pos*dispx+dp.x-dpr; j=dp.y-dpr;
	XFillArc(mydisplay,mywindow,mygc,i,j,2*dpr,2*dpr,0,360*64);
	XFlush(mydisplay);
}

